/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_timer.c,v 1.3.1.2 2006/07/11 00:56:52 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1990, 1993, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)tcp_timer.c	8.2 (Berkeley) 5/24/95
 * $FreeBSD: src/sys/netinet/tcp_timer.c,v 1.28.2.1 1999/08/29 16:29:56 peter Exp $
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net.h>
#include <net/net_var.h>
#include <net/net_buf.h>
#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet6/in6.h>
#include <netinet6/in6_var.h>
#include <netinet/ip.h>
#include <netinet/ip6.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>
#include <netinet/tcp_seq.h>

#ifdef SUPPORT_TCP

/*
 *  ɽؿ
 */

static T_TCP_CCEP *tcp_timers (T_TCP_CCEP *cep, int tix);

#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0

static void tcp_tw_timo (void);

#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */

/*
 *  Хåջ
 *
 *  ԤӤˡॢȤλ֤Ĺ롣
 */

const static UB tcp_back_off[TCP_MAX_REXMT_SHIFT + 1] = {
	1, 2, 4, 8, 16, 32, 64, 64, 64, 64, 64, 64, 64
	};

#define TCP_TOTAL_BACK_OFF	511	/* Хåջ֤ι */

/*
 *  tcp_timers -- ॢȽ
 */

static T_TCP_CCEP *
tcp_timers (T_TCP_CCEP *cep, int tix)
{
	UH	win;


	switch (tix) {

	/*
	 *  
	 */
	case TCP_TIM_REXMT:
	
		/*
		 *   (TCP_MAX_REXMT_SHIFTɸ 12 ) ˤʤäȤϡ
		 *  ͥǤ롣
		 */
		if (++ cep->rxtshift > TCP_MAX_REXMT_SHIFT) {
			cep->rxtshift  = TCP_MAX_REXMT_SHIFT;
			cep->net_error = EV_REXMTMO;
			cep = tcp_drop(cep, E_CLS);
			break;
			}

		/*
		 *  ॢȤ׻롣
		 */
		cep->rxtcur = tcp_range_set((T_TCP_TIME)(tcp_rexmt_val(cep) * tcp_back_off[cep->rxtshift]),
		                            (T_TCP_TIME)TCP_TVAL_MIN, 
		                            (T_TCP_TIME)TCP_TVAL_MAX_REXMT);
		cep->timer[TCP_TIM_REXMT] = cep->rxtcur;

		/*
		 *  srtt:   ʿ경줿 RTT
		 *  rttvar: ʿ경줿ʬ
		 *
		 *   1/4 ˤʤäȤϡ
		 *  ʿ경줿ʬ (rttvar)  srtt û
		 *  ʿ경줿 RTT  0 ˤ롣
		 *  
		 */
		if (cep->rxtshift > TCP_MAX_REXMT_SHIFT / 4) {
			cep->rttvar += (cep->srtt >> TCP_SRTT_SHIFT);
			cep->srtt    = 0;
			}

		/*
		 *  snd_nxt:  SEQλǤϡ SEQ
		 *  snd_una: ̤ǧκǾ SEQ	 ޤϡǧ줿 SEQ
		 *
		 *   SEQ (snd_nxt)  
		 *  ǧ줿 SEQ (snd_una) ޤ᤹
		 */
		cep->snd_nxt = cep->snd_una;
		cep->flags  |= CEP_FLG_ACK_NOW;

		/*
		 *  rtt: ֤η¬ߤ롣
		 */
		cep->rtt     = 0;

		/*
		 *  ɤ
		 *
		 *  snd_wnd:  μǽɥ
		 *  snd_cwnd: ԥɥ
		 *  maxseg  : κȥ
		 *
		 *  μǽɥ (snd_wnd) 
		 *  ԥɥ (snd_cwnd) 
		 *  ɤ餫 1/2 򡢹
		 *  κȥ (maxseg) ǳä͡
		 *  2 ʾ
		 */
		if (cep->snd_wnd < cep->snd_cwnd)
			win = cep->snd_wnd / 2 / cep->maxseg;
		else
			win = cep->snd_cwnd / 2 / cep->maxseg;

		if (win < 2)
			win = 2;

		/*
		 *  ԥɥ (snd_cwnd) 
		 *  μǽɥ (snd_wnd) ˡ
		 *  ԥɥΤ (snd_ssthresh) 
		 *  μǽɥ (snd_wnd)  win ܤ
		 *  ꤹ롣
		 */
		cep->snd_cwnd     = cep->maxseg;
		cep->snd_ssthresh = win * cep->maxseg;
		cep->dupacks      = 0;

		/* ϤݥȤ롣*/
		cep->flags |= CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);
		break;

	/*
	 *  ³	
	 */
	case TCP_TIM_PERSIST:

		/*
		 *   (TCP_MAX_REXMT_SHIFTɸ 12 ) ĶƤơ
		 *  ɥ֤αޤɸ (TCP_TVAL_KEEP_IDLE
		 *  ɸ 2 * 60 * 60 ) ʾ夫
		 *  ॢ * Хåջ֤ιװʾʤ
		 *  ͥǤ롣
		 */
		if (cep->rxtshift > TCP_MAX_REXMT_SHIFT &&
		    (cep->idle >= TCP_TVAL_KEEP_IDLE ||
		     cep->idle >= tcp_rexmt_val(cep) * TCP_TOTAL_BACK_OFF)) {
			cep->net_error = EV_REXMTMO;
			cep = tcp_drop(cep, E_CLS);
			break;
			}

		/* ³ޤꤷϤݥȤ롣*/
		tcp_set_persist_timer(cep);

		cep->flags |= CEP_FLG_FORCE | CEP_FLG_FORCE_CLEAR | CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);
		break;

	/*
	 *  α (keep alive) 
	 */
	case TCP_TIM_KEEP:

		/*
		 *  ͥ󤬳ߤޤǤ˥ॢȤ
		 *  ͥγߤߤ롣
		 */
		if (cep->fsm_state < TCP_FSM_ESTABLISHED) {
			cep->net_error = EV_REXMTMO;
			cep = tcp_drop(cep, E_CLS);
			break;
			}

#ifdef TCP_CFG_ALWAYS_KEEP

		else if (cep->fsm_state < TCP_FSM_CLOSING) {
			if (cep->idle >= TCP_TVAL_KEEP_IDLE + 
			                 TCP_TVAL_KEEP_COUNT * TCP_TVAL_KEEP_INTERVAL) {
				cep->net_error = EV_REXMTMO;
				cep = tcp_drop(cep, E_CLS);
				break;
				}
			else
				tcp_respond(NULL, cep, cep->rcv_nxt, cep->snd_una - 1,
				                       cep->rbufsz - cep->rwbuf_count, 0);
			cep->timer[TCP_TIM_KEEP] = TCP_TVAL_KEEP_INTERVAL;
			}
		else
			cep->timer[TCP_TIM_KEEP] = TCP_TVAL_KEEP_IDLE;

#else	/* of #ifdef TCP_CFG_ALWAYS_KEEP */

		cep->timer[TCP_TIM_KEEP] = TCP_TVAL_KEEP_IDLE;

#endif	/* of #ifdef TCP_CFG_ALWAYS_KEEP */

		break;

	/*
	 *  2MSL 		
	 */
	case TCP_TIM_2MSL:

		if (cep->fsm_state != TCP_FSM_TIME_WAIT &&
		    cep->idle  <= TCP_TVAL_KEEP_COUNT * TCP_TVAL_KEEP_INTERVAL)
			cep->timer[TCP_TIM_2MSL] = TCP_TVAL_KEEP_INTERVAL;
		else
			cep = tcp_close(cep);
		break;
		}

	return cep;
	}

/*
 *  tcp_cancel_timers -- ƤΥޤ򥭥󥻥뤹롣
 */

void
tcp_cancel_timers (T_TCP_CCEP *cep)
{
	int ix;

	for (ix = NUM_TCP_TIMERS; ix -- > 0; )
		cep->timer[ix] = 0;
	}

#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0

/*
 *  tcp_tw_timo -- Time Wait  TCP ̿üΥॢȽ
 */

void
tcp_tw_timo (void)
{
	T_TCP_CCEP	*cep, *lcep;
	T_TCP_TW_CCEP*	tw_cep;
	T_TCP_TIME	longer;
	int		frees, waits;

	/*
	 *  Time Wait  TCP ̿üǥॢȤΥȥõ
	 *  õȥˤ롣
	 */
	frees = 0;
	for (tw_cep = &tcp_tw_ccep[NUM_TCP_TW_CEP_ENTRY]; tw_cep -- != tcp_tw_ccep; )
		if (tw_cep->fsm_state == TCP_FSM_TIME_WAIT && -- tw_cep->timer_2msl == 0) {
			tw_cep->fsm_state = TCP_FSM_CLOSED;
			frees ++;
			}

	/*
	 *  Time Wait  TCP ̿üζȥ꤬ȯ
	 *  ɸ TCP ̿ü Time Wait  TCP ̿üõ
	 *  ɬפʾ Time Wait  TCP ̿ü˰ܤơ
	 *  ɸ TCP ̿ü롣
	 */
	if (frees > 0) {
		waits = 0;
		for (cep = &tcp_ccep[tmax_tcp_ccepid]; cep -- != tcp_ccep; )
			if (cep->fsm_state == TCP_FSM_TIME_WAIT)
				waits ++;
		if (waits > frees)
			waits = frees;

		/*
		 *  äȤĹ Time Wait Ƥ TCP ̿ü롣
		 */
		while (waits > 0) {
			longer = TCP_TVAL_MSL * 2;
			lcep   = NULL;
			for (cep = &tcp_ccep[tmax_tcp_ccepid]; cep -- != tcp_ccep; )
				if (cep->fsm_state == TCP_FSM_TIME_WAIT && cep->timer[TCP_TIM_2MSL] < longer) {
					longer = cep->timer[TCP_TIM_2MSL];
					lcep   = cep;
					}
			if (lcep != NULL) {
				tcp_tw_move_cep(lcep);
				waits --;
				}
			else
				break;
			}
		}
	}

#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */

/*
 *  tcp_slow_timo -- 500 [ms] ˸ƽФ TCP ॢȴؿ
 */

void
tcp_slow_timo (VP ignore)
{
	T_TCP_CCEP	*cep;
	int		cix, tix;

	for (cix = tmax_tcp_ccepid; cix -- > 0; ) {
		cep = &tcp_ccep[cix];
		if (!(cep->fsm_state == TCP_FSM_CLOSED || cep->fsm_state == TCP_FSM_LISTEN)) {
			for (tix = NUM_TCP_TIMERS; cep != NULL && tix -- > 0; ) {
				if (cep->timer[tix] != 0 && -- cep->timer[tix] == 0) {
					cep = tcp_timers(cep, tix);
					}
				}
			if (cep != NULL) {
				cep->idle ++;
				if (cep->rtt) {
					cep->rtt ++;
					}
				}
			}
		}

#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0

	tcp_tw_timo();

#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */

	if (tcp_iss != 0)
		tcp_iss += TCP_ISS_INCR() / TCP_SLOW_HZ;

	timeout((FP)tcp_slow_timo, NULL, TCP_SLOW_TMO);
	}

#ifdef TCP_CFG_DELAY_ACK

/*
 *  tcp_fast_timo -- 200 [ms] ˸ƽФ TCP ॢȴؿ
 */

void
tcp_fast_timo (VP ignore)
{
	T_TCP_CCEP	*cep;
	int		cix;

	for (cix = tmax_tcp_ccepid; cix -- > 0; ) {
		cep = &tcp_ccep[cix];
		if (cep->flags & CEP_FLG_DEL_ACK) {
			cep->flags &= ~CEP_FLG_DEL_ACK;
			cep->flags |=  CEP_FLG_ACK_NOW | CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_TCP_POST_OUTPUT);
			}
		}

	timeout((FP)tcp_fast_timo, NULL, TCP_FAST_TMO);
	}

#endif/* of #ifdef TCP_CFG_DELAY_ACK */

/*
 *  tcp_range_set -- ֤ꤷϰϤꤹ롣
 */

T_TCP_TIME
tcp_range_set (T_TCP_TIME value, T_TCP_TIME tvmin, T_TCP_TIME tvmax)
{
	if ((UW)value < (UW)tvmin)
		return tvmin;
	else if ((UW)value > (UW)tvmax)
		return tvmax;
	else
		return value;
	}

/*
 *  tcp_set_persist_timer -- ³ޤ
 */

void
tcp_set_persist_timer (T_TCP_CCEP *cep)
{
	T_TCP_TIME time;

	/*
	 *  srtt:   ʿ경줿 RTT
	 *  rttvar: ʿ경줿ʬ
	 */
	time = ((cep->srtt >> 2) + cep->rttvar) >> 1;

	/*
	 *  ޤꤵƤвǽ顼
	 */
	if (cep->timer[TCP_TIM_REXMT])
		/* %%% panic("tcp_output REXMT"); %%% */;

	/*
	 *  ³ޤꤹ롣
	 */
	cep->timer[TCP_TIM_PERSIST] = tcp_range_set((T_TCP_TIME)(time * tcp_back_off[cep->rxtshift]),
	                                            (T_TCP_TIME)TCP_TVAL_MIN_PERSIST,
	                                            (T_TCP_TIME)TCP_TVAL_MAX_PERSIST);

	/*
	 *  򹹿롣
	 */
	if (cep->rxtshift < TCP_MAX_REXMT_SHIFT)
		cep->rxtshift ++;
	}

#endif	/* of #ifdef SUPPORT_TCP */
