/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: nd6.h,v 1.3.1.2 2006/07/11 00:57:21 abe Exp abe $
 */

/*	$FreeBSD: src/sys/netinet6/nd6.h,v 1.10 2002/04/19 04:46:23 suz Exp $	*/
/*	$KAME: nd6.h,v 1.76 2001/12/18 02:10:31 itojun Exp $	*/

/*
 * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
 
#ifndef _ND6_H_
#define _ND6_H_

#ifdef SUPPORT_INET6

/*
 *  ٥å 
 */

typedef struct t_llinfo_nd6 {
	T_IN6_ADDR	addr;
	T_NET_BUF	*hold;
	TMO		tmout;
	SYSTIM		expire;		/* [ms] ֤ͭڤ	*/
	T_IF_ADDR	ifaddr;
	UB		state;
	UB		asked;
	} T_LLINFO_ND6;

/* ٥åξ */

#define ND6_LLINFO_FREE			0	/* ̤		*/
#define ND6_LLINFO_NO_STATE		1	/* ̤		*/
#define ND6_LLINFO_INCOMPLETE		2	/* ̤		*/
#define ND6_LLINFO_REACHABLE		3	/* ãǽ		*/
#define ND6_LLINFO_STALE		4	/* ãǽ̤ǧ	*/
#define ND6_LLINFO_DELAY		5	/* ãǽγǧԵ	*/
#define ND6_LLINFO_PROBE		6	/* ãǽǧ	*/

/* õå塢֤ͭ */

#define ND6_SLOW_TMO			((60*60)/NET_TIMER_HZ)
							/* 1 []				*/
							/* õå幹ॢ	*/

#define ND6_MAX_DAD_TRY			15		/* ʣɥ쥹Фκ		*/
#define ND6_MAX_MCAST_QUERY		3		/* ޥ㥹ȥɥ쥹κ	*/
#define ND6_MAX_UCAST_QUERY		3		/* ˥㥹ȥɥ쥹κ	*/

#define ND6_INFINITE_LIFETIME		0xffffffff

#define ND6_GCOLLECTION_TIME		(60*60*24*SYSTIM_HZ)
							/* ߽1 			*/
#define	ND6_DELAY_TIME			(5*SYSTIM_HZ)	/* ǧԵٱ				*/
#define ND6_FIRST_DAD_DELAY_TIME	(1*SYSTIM_HZ)	/* ǽνʣɥ쥹ٱ		*/
#define ND6_DAD_DELAY_TIME		(5*SYSTIM_HZ/10)
							/* ʣɥ쥹ٱ		*/

/*
 *  ãǽ֤ͭ
 */

#define	ND6_DEF_REACHABLE_TIME		(30*SYSTIM_HZ)	/* ãǽ֤֤ͭδ		*/
#define	ND6_MAX_REACHABLE_TIME		(60*60*SYSTIM_HZ)
							/* ãǽ֤֤ͭδ		*/
#define	ND6_RECALC_REACHTM_INTERVAL	(60*60*2*SYSTIM_HZ)
							/* ãǽֺ֤ͭƷ׻ֳ	*/

#define	ND6_MIN_REACHTM_RAND_FACTOR	512		/* Ǿ͡1,024 * 0.5		*/
#define	ND6_MAX_REACHTM_RAND_FACTOR	1536		/* Ǿ͡1,024 * 1.5		*/

/* ãǽ֤֤ͭη׻ޥ */

#define ND6_CALC_REACH_TIME(b)		\
	 ((ND6_MIN_REACHTM_RAND_FACTOR * ((UB)(b) >> 10)) + \
	  (net_rand() & ((ND6_MAX_REACHTM_RAND_FACTOR - ND6_MIN_REACHTM_RAND_FACTOR) * ((UB)(b) >> 10))))

/*
 *  õֳ
 */

#define ND6_DEF_RETRANS_TIME		(1*SYSTIM_HZ)

/*
 *  롼Τˤѹ뤳Ȥ
 */

#if NUM_ND6_DEF_RTR_ENTRY > 0

/* 롼ΤϡΤ줿 */

#define	ND6_REACHABLE_TIME		nd6_reachable_time
#define ND6_RETRANS_TIME		nd6_retrans_time

#else	/* #if NUM_ND6_DEF_RTR_ENTRY > 0 */

/* 롼Τʤͤϴ */

#define	ND6_REACHABLE_TIME		ND6_DEF_REACHABLE_TIME
#define ND6_RETRANS_TIME		ND6_DEF_RETRANS_TIME

#endif	/* #if NUM_ND6_DEF_RTR_ENTRY > 0 */

/*
 *  ǥեȥ롼ꥹ
 */

typedef struct t_def_router {
	T_IN6_ADDR	addr;
	SYSTIM		expire;		/* [ms] ֤ͭڤ	*/
	UW		lifetime;	/* [ms] ͭ			*/
	UB		flags;
	UB		state;
	} T_DEF_ROUTER;

/* ǥեȥ롼ꥹȤξ */

#define ND6_DEF_RTR_FREE		0	/* ̤		*/
#define ND6_DEF_RTR_BUSY		1	/* 		*/

/*
 *  ץեåꥹ
 */

typedef struct t_nd_prefix {
	T_IN6_ADDR	prefix;		/* ץեå		*/
	UW		expire;		/* [s] ֤ͭڤ	*/
	UW		preferred;	/* [s] 侩֤ͭڤ	*/
	UW		vltime;		/* [s] ͭ			*/
	UW		pltime;		/* [s] 侩ͭ		*/
	UB		prefix_len;	/* ץեåĹ		*/
	UB		frags;		/* ե饰			*/
	} T_ND_PREFIX;

/*
 *  ѿ
 */

extern SYSTIM	nd6_base_reachable_time;
extern SYSTIM	nd6_reachable_time;
extern SYSTIM	nd6_recalc_reachtm_interval;
extern SYSTIM	nd6_retrans_time;
extern UB	ip6_defhlim;

/*
 *  ؿ
 */

extern void nd6_ifattach (T_IFNET *ifp);
extern void nd6_ns_output (T_IFNET *ifp, T_IN6_ADDR *daddr,
                           T_IN6_ADDR *taddr, T_LLINFO_ND6 *ln, BOOL dad);
extern void nd6_na_output (T_IFNET *ifp, T_IN6_ADDR *daddr,
                           T_IN6_ADDR *taddr, UB flags, BOOL tlladdr);
extern void nd6_dad_start (T_IFNET *ifp, T_IN6_IFADDR *ia, int *tick);
extern ER nd6_output (T_IFNET *ifp, T_NET_BUF *output,
                      T_IN6_ADDR *dst, T_LLINFO_ND6 *ln, TMO tmout);
extern void nd6_na_input (T_NET_BUF *input, UINT off);
extern void nd6_ns_input (T_NET_BUF *input, UINT off);
extern void nd6_ra_input (T_NET_BUF *input, UINT off);
extern ER nd6_storelladdr (T_IF_ADDR *out, T_IN6_ADDR *dst, T_IF_ADDR *ifa);
extern ER nd6_options (UB *opt, VP nh, UINT len);
extern T_LLINFO_ND6 *nd6_lookup (T_IN6_ADDR *addr, BOOL create);
extern ER nd6_output_hold (T_IFNET *ifp, T_LLINFO_ND6 *ln);
extern T_LLINFO_ND6 *nd6_cache_lladdr (T_IFNET *ifp, T_IN6_ADDR *from, 
                                       T_IF_ADDR *lladdr, UB type, UB code);
extern void nd6_defrtrlist_timer (void);
extern void nd6_rtrsol_ctl (void);
extern T_IN6_ADDR *nd6_router_lookup (T_IFNET *ifp, T_IN6_ADDR *dst);
extern T_DEF_ROUTER *nd6_defrtrlist_lookup (T_IN6_ADDR *src);
extern void nd6_timer (void);
extern const T_DEF_ROUTER *nd6_get_drl (void);
extern const T_LLINFO_ND6 *nd6_get_cache (void);

#endif	/* of #ifdef SUPPORT_INET6 */

#endif	/* of #ifndef _ND6_H_ */
