/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: nd6_nbr.c,v 1.3.1.2 2006/07/11 00:57:21 abe Exp abe $
 */

/*	$FreeBSD: src/sys/netinet6/nd6_nbr.c,v 1.13 2002/10/16 01:54:45 sam Exp $	*/
/*	$KAME: nd6_nbr.c,v 1.86 2002/01/21 02:33:04 jinmei Exp $	*/

/*
 * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <string.h>

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/if_arp.h>
#include <net/ppp_ipcp.h>
#include <net/net.h>
#include <net/net_var.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet/in_var.h>

#include <netinet6/in6.h>
#include <netinet6/in6_var.h>
#include <netinet6/nd6.h>

#include <netinet/ip6.h>
#include <netinet/icmp6.h>
#include <netinet6/ip6_var.h>

#include <net/if6_var.h>

#ifdef SUPPORT_INET6

/*
 *  ɽؿ
 */

static void nd6_dad_timer (T_IN6_IFADDR *ifa);
static void nd6_dad_duplicated (T_IN6_IFADDR *ifa);
static void nd6_dad_ns_output (T_IFNET *ifp, T_IN6_IFADDR *ifa);
static void nd6_dad_ns_input (T_IN6_IFADDR *ifa);
static void nd6_dad_na_input (T_IN6_IFADDR *ifa);

/*
 *  nd6_dad_duplicated -- ʣɥ쥹򸡽Фν
 */

static void
nd6_dad_duplicated (T_IN6_IFADDR *ifa)
{
	if ((ifa->flags & IN6_IFF_TENTATIVE) == 0)
		syslog(LOG_ERROR, "[ND6 DAD DUP] no pending.");
	else {
		syslog(LOG_ERROR, "[ND6 DAD DUP] dup IPv6 addr: %s.", ipv62str(NULL, &ifa->addr));
		ifa->flags &= ~IN6_IFF_TENTATIVE;
		ifa->flags |=  IN6_IFF_DUPLICATED;

		/* ޡߤ롣*/
		untimeout((FP)nd6_dad_timer, ifa);
		}
	}

/*
 *  nd6_dad_ns_output -- ʣɥ쥹 (DAD) Ϥ롣
 */

static void
nd6_dad_ns_output (T_IFNET *ifp, T_IN6_IFADDR *ifa)
{
	NET_COUNT_ICMP6(net_count_nd6[NC_ND6_DAD_OUT_PACKETS], 1);

	ifa->ns_ocount ++;
	nd6_ns_output(ifp, &in6_addr_unspecified, &ifa->addr, NULL, TRUE);
	}

/*
 *  nd6_dad_ns_input -- ʣɥ쥹 (DAD) 
 */

static void
nd6_dad_ns_input (T_IN6_IFADDR *ifa)
{
	NET_COUNT_ICMP6(net_count_nd6[NC_ND6_NS_IN_PACKETS], 1);

	/*
	 *  ޤʣɥ쥹ϤƤʤ
	 */
	if (ifa->ns_ocount == 0)
		nd6_dad_duplicated(ifa);
	else
		ifa->ns_icount ++;
	}

/*
 *  nd6_dad_na_input -- ʣɥ쥹 (DAD) 
 */

static void
nd6_dad_na_input (T_IN6_IFADDR *ifa)
{
	NET_COUNT_ICMP6(net_count_nd6[NC_ND6_NA_IN_PACKETS], 1);
	ifa->na_icount ++;
	nd6_dad_duplicated(ifa);
	}

/*
 *  nd6_dad_timer -- ʣɥ쥹 (DAD) ޡ
 */

static void
nd6_dad_timer (T_IN6_IFADDR *ifa)
{
	if (ifa->flags & IN6_IFF_DUPLICATED) {
		syslog(LOG_ERROR, "[ND6 DAD TIMER] dup IPv6 addr: %s.", ipv62str(NULL, &ifa->addr));
		return;
		}

	if ((ifa->flags & IN6_IFF_TENTATIVE) == 0) {
		syslog(LOG_ERROR, "[ND6 DAD TIMER] no tentative IPv6 addr: %s.", ipv62str(NULL, &ifa->addr));
		return;
		}

	if (ifa->ns_ocount < NUM_IP6_DAD_COUNT) {
		nd6_dad_ns_output(IF_GET_IFNET(), ifa);

		/* ॢȤõֳ֤ꤹ롣*/
		timeout((FP)nd6_dad_timer, ifa, ND6_RETRANS_TIME * NET_TIMER_HZ / SYSTIM_HZ);
		}
	else if (ifa->na_icount || ifa->ns_icount)
		nd6_dad_duplicated(ifa);
	else {
		ifa->flags &= ~IN6_IFF_TENTATIVE;
		syslog(LOG_NOTICE, "[ND6 DAD TIMER] no dup IPv6 addr: %s.", ipv62str(NULL, &ifa->addr));
		}
	}

/*
 *  nd6_ns_input -- Ͻ
 */

void
nd6_ns_input (T_NET_BUF *input, UINT off)
{
	T_IP6_HDR		*ip6h;
	T_NEIGHBOR_SOLICIT_HDR	*nsh;
	T_ND_OPT_HDR		*opth;
	T_IN6_IFADDR		*ifa;
	T_IFNET			*ifp = IF_GET_IFNET();
	UINT			lladdr_len = 0;
	BOOL			tlladdr;
	UB			flags, *lladdr = NULL;
	UB			nd_opt_off[ND_OPT_OFF_ARRAY_SIZE];

	NET_COUNT_ICMP6(net_count_nd6[NC_ND6_NS_IN_PACKETS], 1);

	ip6h = GET_IP6_HDR(input);

	/*
	 *  إåΥåʲξ˴롣
	 *    ۥåץߥåȤ IPV6_MAXHLIM (255) ʳ
	 *    إåĹû
	 */
	if (ip6h->hlim != IPV6_MAXHLIM || input->len - off < NEIGHBOR_SOLICIT_HDR_SIZE)
		goto err_ret;

	nsh  = (T_NEIGHBOR_SOLICIT_HDR *)(input->buf + off);

	if (IN6_IS_ADDR_UNSPECIFIED(&nsh->target)) {
		/*
		 *  Ūɥ쥹̵ʤ顢ʣɥ쥹
		 *  襢ɥ쥹ϡޥ㥹ȤǤʤФʤʤ
		 */
		if (!IN6_IS_ADDR_NS_MULTICAST(&ip6h->dst))
			goto err_ret;
		}

	/* Ūɥ쥹ޥ㥹Ȥʤ饨顼 */
	if (IN6_IS_ADDR_MULTICAST(&nsh->target))
		goto err_ret;

	/* õץΥեåȤϿ롣*/
	if (nd6_options(nd_opt_off, input->buf + (off + NEIGHBOR_SOLICIT_HDR_SIZE),
	                            input->len - (off + NEIGHBOR_SOLICIT_HDR_SIZE)) != E_OK)
		goto err_ret;

	/* õץ (󥯥ɥ쥹) */
	if (nd_opt_off[ND_OPT_OFF_ARRAY_IX(ND_OPT_SOURCE_LINKADDR)]) {
		opth = (T_ND_OPT_HDR *)((UB *)(input->buf + off + NEIGHBOR_SOLICIT_HDR_SIZE) +
		                        nd_opt_off[ND_OPT_OFF_ARRAY_IX(ND_OPT_SOURCE_LINKADDR)] - 8);
	 	/* : ץ󥪥եåˤϡեå + 8 ꤵƤ롣*/
		lladdr     = (UB *)(opth + 1);
		lladdr_len = (opth->len << 3);
		}

	if (IN6_IS_ADDR_UNSPECIFIED(&ip6h->src) && lladdr != NULL)
		goto err_ret;

	/* 襢ɥ쥹ޥ㥹ȤʤΤ˥ǡؤΥɥ쥹դ롣*/
	if (IN6_IS_ADDR_MULTICAST(&ip6h->dst))
		tlladdr = TRUE;
	else
		tlladdr = FALSE;

	/*
	 *  Ūɥ쥹ʬΥͥåȥ󥿥ե
	 *  ƤƤ륢ɥ쥹Ĵ٤롣
	 *  ʤӥϼƤʤ
	 */
	ifa = in6ifa_ifpwithaddr(ifp, &nsh->target);

	if (ifa == NULL)
		goto free_ret;

	/* õ̥ɥ쥹ʣƤбʤǽλ롣*/
	if (ifa->flags & IN6_IFF_DUPLICATED)
		goto err_ret;

	/*
	 *  ͥåȥ󥿥եΥɥ쥹ĹפʤХ顼
	 */
	if (lladdr && lladdr_len != ((sizeof(T_IF_ADDR) + sizeof(T_ND_OPT_HDR) + 7) & ~7))
		goto err_ret;

	/*
	 *  ɥ쥹ʬΥɥ쥹ȰפнʣƤ롣
	 */
	if (IN6_ARE_ADDR_EQUAL(&ifa->addr, &ip6h->src))
		goto free_ret;

	/* ʣˡȤν */
	if (ifa->flags & IN6_IFF_TENTATIVE) {
		if (IN6_IS_ADDR_UNSPECIFIED(&ip6h->src))
			nd6_dad_ns_input(ifa);
		goto free_ret;
		}

	if ((ifa->flags & IN6_IFF_ANYCAST) || !tlladdr)
		flags = 0;
	else
		flags = ND_NA_FLG_OVERRIDE;

	/*
	 *  ɥ쥹̵ʤ顢Ͻʣɥ쥹ǡ
	 *  ľ뤳ȤϤǤʤΤǡΡɥޥ㥹
	 *  ɥ쥹롣
	 */
	if (IN6_IS_ADDR_UNSPECIFIED(&ip6h->src)) {
		nd6_na_output(ifp, &in6_addr_linklocal_allnodes, &nsh->target, flags, tlladdr);
		goto free_ret;
		}

	/* ٥åϿ롣*/
	nd6_cache_lladdr(ifp, &ip6h->src, (T_IF_ADDR *)lladdr, ND_NEIGHBOR_SOLICIT, 0);

	nd6_na_output(ifp, &ip6h->src, &nsh->target, flags | ND_NA_FLG_SOLICITED, tlladdr);

free_ret:
	syscall(rel_net_buf(input));
	return;

err_ret:
	NET_COUNT_ICMP6(net_count_nd6[NC_ICMP6_IN_ERR_PACKETS], 1);
	syscall(rel_net_buf(input));
	}

/*
 *  nd6_ns_output -- Ϥ롣
 */

void
nd6_ns_output (T_IFNET *ifp, T_IN6_ADDR *daddr,
               T_IN6_ADDR *taddr, T_LLINFO_ND6 *ln, BOOL dad)
{
	T_NEIGHBOR_SOLICIT_HDR	*nsh;
	T_NET_BUF		*output;
	T_IP6_HDR		*ip6h;
	T_IF_ADDR		*mac;
	UINT			len;
	UH			ipflags = 0;

	NET_COUNT_ICMP6(net_count_nd6[NC_ND6_NS_OUT_PACKETS], 1);

	if (IN6_IS_ADDR_MULTICAST(taddr))
		return;

	/* ڥĹ׻롣*/
	if (!dad && IF_SOFTC_TO_IFADDR(ifp->ic))
		len = (NEIGHBOR_SOLICIT_HDR_SIZE + ND_OPT_HDR_SIZE + sizeof(T_IF_ADDR) + 7) >> 3 << 3;
	else
		len = (NEIGHBOR_SOLICIT_HDR_SIZE + 7) >> 3 << 3;

	/*
	 *  ޥ㥹ȡɥ쥹ζõǤϡ
	 *  ¾Υ󥯤ε¤줿ǡ
	 *  ӽ뤿ᡢۥåץߥåȤ IPV6_MAXHLIM (255) ꤹ롣
	 */
	if (IN6_IS_ADDR_UNSPECIFIED(daddr) || IN6_IS_ADDR_MULTICAST(daddr))
		ipflags = IPV6_OUT_SET_HOP_LIMIT(IPV6_OUT_FLG_HOP_LIMIT, IPV6_MAXHLIM);

	/* ͥåȥХåեIPv6 إåꤹ롣*/
	if (in6_get_datagram(&output, len, 0, daddr, NULL,
	                     IPPROTO_ICMPV6, IPV6_MAXHLIM,
	                     NBA_SEARCH_ASCENT, TMO_ND6_NS_OUTPUT) != E_OK)
		return;

	ip6h = GET_IP6_HDR(output);

	if (IN6_IS_ADDR_UNSPECIFIED(daddr)) {

		/* 襢ɥ쥹̵ξϡޥ㥹ȥɥ쥹ꤹ롣*/
		ip6h->dst.s6_addr32[0] = IPV6_ADDR_INT32_MLL;
		ip6h->dst.s6_addr32[2] = IPV6_ADDR_INT32_ONE;
		ip6h->dst.s6_addr32[3] = taddr->s6_addr32[3];
		ip6h->dst.s6_addr8[12] = 0xff;
		}

	/* ɥ쥹 */
	if (!dad) {

		/* ʣɥ쥹ФǤϤʤɥ쥹*/
		T_IN6_ADDR *saddr;

		if (ln && ln->hold) {
			/*
			 * ٥åݻƤǡ
			 * ɥ쥹Ѥ롣
			 */
			if (ln->hold->len > IF_IP6_HDR_SIZE)
				saddr = &GET_IP6_HDR(ln->hold)->src;
			else
				saddr = NULL;
			}
		else
			saddr = NULL;

		if (saddr && in6ifa_ifpwithaddr(ifp, saddr))
			ip6h->src = *saddr;
		else {
			/*
			 *  襢ɥ쥹ˤդ路ɥ쥹
			 *  ͥåȥ󥿥եõѤ롣
			 */
			T_IN6_IFADDR *ifa;

			if ((ifa = in6_ifawithifp(ifp, &ip6h->dst)) == NULL) {
				syscall(rel_net_buf(output));
				return;
				}
			ip6h->src = ifa->addr;
			}
		}
	else {
	
		/* ʣɥ쥹лɥ쥹̵ꡣ*/
		memset(&ip6h->src, 0, sizeof(T_IN6_ADDR));
		}

 	/* إåꤹ롣*/
 	nsh = GET_NEIGHBOR_SOLICIT_HDR(output, IF_IP6_NEIGHBOR_SOLICIT_HDR_OFFSET);
 	nsh->hdr.type        = ND_NEIGHBOR_SOLICIT;
 	nsh->hdr.code        = 0;
 	nsh->hdr.data.data32 = 0;
 	nsh->target          = *taddr;

	if (!dad && (mac = IF_SOFTC_TO_IFADDR(ifp->ic))) {

		/* õץȤơõɸ MAC ɥ쥹ꤹ롣*/
		T_ND_OPT_HDR	*opth;
		UINT		optlen;

		opth   = (T_ND_OPT_HDR *)GET_NEIGHBOR_SOLICIT_SDU(output, IF_IP6_NEIGHBOR_SOLICIT_HDR_OFFSET);
		optlen = (ND_OPT_HDR_SIZE + sizeof(T_IF_ADDR) + 7) >> 3 << 3;
		memset(opth, 0, optlen);
		opth->type = ND_OPT_SOURCE_LINKADDR;
		opth->len  = optlen >> 3;
		memcpy((UB *)opth + sizeof(T_ND_OPT_HDR), mac, sizeof(T_IF_ADDR));
		}

	/* å׻롣*/
	nsh->hdr.sum = 0;
	nsh->hdr.sum = in6_cksum(output, IPPROTO_ICMPV6, (UB*)nsh - output->buf, len);

	/* 롣*/
	NET_COUNT_ICMP6(net_count_nd6[NC_ICMP6_OUT_OCTETS],
	               output->len - GET_IF_IP6_HDR_SIZE(output));
	NET_COUNT_ICMP6(net_count_nd6[NC_ICMP6_OUT_PACKETS], 1);
	NET_COUNT_MIB(icmp6_ifstat.ipv6IfIcmpOutMsgs, 1);
	NET_COUNT_MIB(icmp6_ifstat.ipv6IfIcmpOutNeighborSolicits, 1);
	ip6_output(output, ipflags | IPV6_OUT_FLG_DAD, TMO_ND6_NS_OUTPUT);
	}

/*
 *  nd6_na_input -- ΤϽ
 */

void
nd6_na_input (T_NET_BUF *input, UINT off)
{
	T_IP6_HDR		*ip6h;
	T_NEIGHBOR_ADVERT_HDR	*nah;
	T_ND_OPT_HDR		*opth;
	T_IN6_IFADDR		*ifa;
	T_IFNET			*ifp = IF_GET_IFNET();
	T_LLINFO_ND6		*ln;
	SYSTIM			now;
	UINT			lladdr_len = 0;
	BOOL			llchange;
	UB			*lladdr = NULL;
	UB			nd_opt_off[ND_OPT_OFF_ARRAY_SIZE];

	NET_COUNT_ICMP6(net_count_nd6[NC_ND6_NS_IN_PACKETS], 1);

	ip6h = GET_IP6_HDR(input);

	/*
	 *  إåΥåʲξ˴롣
	 *    ۥåץߥåȤ IPV6_MAXHLIM (255) ʳ
	 *    إåĹû
	 */
	if (ip6h->hlim != IPV6_MAXHLIM || input->len - off < NEIGHBOR_ADVERT_HDR_SIZE)
		goto err_ret;

	nah  = (T_NEIGHBOR_ADVERT_HDR *)(input->buf + off);

	/* Ūɥ쥹ޥ㥹Ȥʤ饨顼 */
	if (IN6_IS_ADDR_MULTICAST(&nah->target))
		goto err_ret;

	/* ؤαǡ襢ɥ쥹ޥ㥹Ȥʤ饨顼 */
	if ((nah->nd_na_flags & ND_NA_FLG_SOLICITED) &&
	    IN6_IS_ADDR_MULTICAST(&ip6h->dst))
		goto err_ret;

	/* õץΥեåȤϿ롣*/
	if (nd6_options(nd_opt_off, input->buf + (off + NEIGHBOR_ADVERT_HDR_SIZE), 
	                            input->len - (off + NEIGHBOR_ADVERT_HDR_SIZE)) != E_OK)
		goto err_ret;

	/* õץ (Ū󥯥ɥ쥹) */
	if (nd_opt_off[ND_OPT_OFF_ARRAY_IX(ND_OPT_TARGET_LINKADDR)]) {
		opth = (T_ND_OPT_HDR *)((UB *)(input->buf + off + NEIGHBOR_ADVERT_HDR_SIZE) +
		                        nd_opt_off[ND_OPT_OFF_ARRAY_IX(ND_OPT_TARGET_LINKADDR)] - 8);
	 	/* : ץ󥪥եåˤϡեå + 8 ꤵƤ롣*/
		lladdr     = (UB *)(opth + 1);
		lladdr_len = (opth->len << 3);
		}

	ifa = in6ifa_ifpwithaddr(ifp, &nah->target);

	/*
	 *  Ūɥ쥹ʬΥͥåȥ󥿥ե˳ƤƤ륢ɥ쥹
	 *  줫˰פȤϡʣƤ뤳Ȥ̣Ƥ롣
	 */
	if (ifa) {
		if (ifa->flags & IN6_IFF_TENTATIVE)
			nd6_dad_na_input(ifa);
		else
			syslog(LOG_ERROR, "[ND6 NA INPUT] dup IPv6 addr: %s.", ipv62str(NULL, &ifa->addr));
		goto free_ret;
		}

	/*
	 *  ͥåȥ󥿥եΥɥ쥹ĹפʤХ顼
	 */
	if (lladdr && lladdr_len != ((sizeof(T_IF_ADDR) + sizeof(T_ND_OPT_HDR) + 7) & ~7))
		goto err_ret;

	/* ٥åõ롣*/
	syscall(wai_sem(SEM_ND6_CACHE));
	if ((ln = nd6_lookup(&nah->target, FALSE)) == NULL)
		goto free_ret;

	/* ٥åξ֤ǡؤΥɥ쥹̤ξ */
	if (ln->state == ND6_LLINFO_INCOMPLETE) {
		/* Τ줿ǡؤΥɥ쥹Ĺ 0 ξ */
		if (lladdr == NULL)
			goto free_ret;

		ln->ifaddr = *(T_IF_ADDR *)lladdr;
		if (nah->nd_na_flags & ND_NA_FLG_SOLICITED) {
			ln->state = ND6_LLINFO_REACHABLE;
			/*ln->byhint = 0*/;
			if (ln->expire) {
				syscall(get_tim(&now));
				ln->expire = now + ND6_REACHABLE_TIME;
				}
			}
		else {
			syscall(get_tim(&now));
			ln->expire = now + ND6_GCOLLECTION_TIME;
			ln->state  = ND6_LLINFO_STALE;
			}

		if (nah->nd_na_flags & ND_NA_FLG_ROUTER)
			/*pfxlist_onlink_check()*/;
		}
	else {
		if (lladdr == NULL)
			llchange = FALSE;
		else if (memcmp(lladdr, &ln->ifaddr, sizeof(T_IF_ADDR)))
			llchange = TRUE;
		else
			llchange = FALSE;

		/*
		 *  ɽ
		 *
		 *  nd_na_flags
		 *  OVERRIDE    SOLICTED lladdr llchange  (L: lladdr Ͽ)
		 *
		 *      F           F       N      -    (2c)
		 *      F           F       Y      F    (2b) L
		 *      F           F       Y      T    (1)    REACHABLE -> STALE
		 *      F           T       N      -    (2c)           * -> REACHABLE
		 *      F           T       Y      F    (2b) L         * -> REACHABLE
		 *      F           T       Y      T    (1)    REACHABLE -> STALE
		 *      T           F       N      -    (2a)
		 *      T           F       Y      F    (2a) L
		 *      T           F       Y      T    (2a) L         *-> STALE
		 *      T           T       N      -    (2a)           * -> REACHABLE
		 *      T           T       Y      F    (2a) L         * -> REACHABLE
		 *      T           T       Y      T    (2a) L         * -> REACHABLE
		 */
		if ((nah->nd_na_flags & ND_NA_FLG_OVERRIDE) == 0 && (lladdr != NULL && llchange)) {	/* (1) */
			/* ֤ REACHABLE ʤ STALE ܤ롣*/
			if (ln->state == ND6_LLINFO_REACHABLE) {
				syscall(get_tim(&now));
				ln->expire = now + ND6_GCOLLECTION_TIME;
				ln->state  = ND6_LLINFO_STALE;
				}
			goto free_ret;
			}
		else if ((nah->nd_na_flags & ND_NA_FLG_OVERRIDE) ||						/* (2a) */
		         ((nah->nd_na_flags & ND_NA_FLG_OVERRIDE) == 0 && (lladdr != NULL && !llchange)) ||	/* (2b) */
		         lladdr == NULL) {									/* (2c) */

			/* ǡؤΥɥ쥹ΤƤй롣*/
			if (lladdr != NULL)
				ln->ifaddr = *(T_IF_ADDR *)lladdr;

			/* ؤαʤ REACHABLE ܤ롣*/
			if (nah->nd_na_flags & ND_NA_FLG_SOLICITED) {
				ln->state = ND6_LLINFO_REACHABLE;
				/*ln->byhint = 0*/;
				if (ln->expire) {
					syscall(get_tim(&now));
					ln->expire = now + ND6_REACHABLE_TIME;
					}
				}
			/*
			 *  ǡؤΥɥ쥹Τ졢
			 *  ۤʤ륢ɥ쥹ʤ鹹롣
			 */
			else if (lladdr != NULL && llchange) {
				syscall(get_tim(&now));
				ln->expire = now + ND6_GCOLLECTION_TIME;
				ln->state  = ND6_LLINFO_STALE;
				}
			}

		/* 롼Τν̤ */
		/*if (ln->router && (nah->nd_na_flags & ND_NA_FLG_ROUTER) == 0) {
			}*/
		}

	ln->asked = 0;

	/* ɥ쥹ԤΥǡब롣*/
	nd6_output_hold(ifp, ln);

free_ret:
	syscall(sig_sem(SEM_ND6_CACHE));
	syscall(rel_net_buf(input));
	return;

err_ret:
	NET_COUNT_ICMP6(net_count_nd6[NC_ICMP6_IN_ERR_PACKETS], 1);
	syscall(rel_net_buf(input));
	}

/*
 *  nd6_na_output -- ΤϤ롣
 */

void
nd6_na_output (T_IFNET *ifp, T_IN6_ADDR *daddr,
               T_IN6_ADDR *taddr, UB flags, BOOL tlladdr)
{
	T_NEIGHBOR_ADVERT_HDR	*nah;
	T_NET_BUF		*output;
	T_IP6_HDR		*ip6h;
	T_IN6_IFADDR		*ifa;
	T_IF_ADDR		*mac;
	UINT			len;
	UH			ipflags = 0;

	NET_COUNT_ICMP6(net_count_nd6[NC_ND6_NA_OUT_PACKETS], 1);

	/*
	 *  ΥڥĹ׻롣
	 *  tlladdr ʤͥåȥ󥿥եΥɥ쥹ɲä롣
	 */
	if (tlladdr && IF_SOFTC_TO_IFADDR(ifp->ic))
		len = (NEIGHBOR_ADVERT_HDR_SIZE + ND_OPT_HDR_SIZE + sizeof(T_IF_ADDR) + 7) >> 3 << 3;
	else
		len = (NEIGHBOR_ADVERT_HDR_SIZE + 7) >> 3 << 3;

	/*
	 *  ¾Υ󥯤ε¤줿ǡ
	 *  ӽ뤿ᡢۥåץߥåȤ IPV6_MAXHLIM (255) ꤹ롣
	 */
	ipflags = IPV6_OUT_SET_HOP_LIMIT(IPV6_OUT_FLG_HOP_LIMIT, IPV6_MAXHLIM);

	/* ͥåȥХåեIPv6 إåꤹ롣*/
	if (in6_get_datagram(&output, len, 0, daddr, NULL,
	                     IPPROTO_ICMPV6, IPV6_MAXHLIM,
	                     NBA_SEARCH_ASCENT, TMO_ND6_NA_OUTPUT) != E_OK)
		return;

	ip6h = GET_IP6_HDR(output);

	if (IN6_IS_ADDR_UNSPECIFIED(daddr)) {
		/*
		 *  襢ɥ쥹̵ξϡ
		 *  󥯥Ρɡޥ㥹ȥɥ쥹ꤹ롣
		 */
		ip6h->dst.s6_addr32[0] = IPV6_ADDR_INT32_MLL;
		ip6h->dst.s6_addr32[1] = 0;
		ip6h->dst.s6_addr32[2] = 0;
		ip6h->dst.s6_addr32[3] = IPV6_ADDR_INT32_ONE;
		flags &= ~ND_NA_FLG_SOLICITED;
		}
	else
		ip6h->dst = *daddr;

	/*
	 *  襢ɥ쥹ˤդ路ɥ쥹
	 *  ͥåȥ󥿥եõѤ롣
	 */
	if ((ifa = in6_ifawithifp(ifp, &ip6h->dst)) == NULL) {
		syscall(rel_net_buf(output));
		return;
		}
	ip6h->src = ifa->addr;

 	/* Υإåꤹ롣*/
 	nah = GET_NEIGHBOR_ADVERT_HDR(output, IF_IP6_NEIGHBOR_ADVERT_HDR_OFFSET);
 	nah->hdr.type        = ND_NEIGHBOR_ADVERT;
 	nah->hdr.code        = 0;
 	nah->target          = *taddr;

	/* tlladdr ʤͥåȥ󥿥եΥɥ쥹ɲä롣*/
	if (tlladdr && (mac = IF_SOFTC_TO_IFADDR(ifp->ic))) {

		T_ND_OPT_HDR	*opth;
		UINT		optlen;

		opth   = (T_ND_OPT_HDR *)GET_NEIGHBOR_ADVERT_SDU(output, IF_IP6_NEIGHBOR_ADVERT_HDR_OFFSET);
		optlen = (ND_OPT_HDR_SIZE + sizeof(T_IF_ADDR) + 7) >> 3 << 3;
		memset(opth, 0, optlen);
		opth->type = ND_OPT_TARGET_LINKADDR;
		opth->len  = optlen >> 3;
		memcpy((UB *)opth + sizeof(T_ND_OPT_HDR), mac, sizeof(T_IF_ADDR));
		}
	else
		flags &= ~ND_NA_FLG_OVERRIDE;

	nah->nd_na_flags = flags;

	/* å׻롣*/
	nah->hdr.sum = 0;
	nah->hdr.sum = in6_cksum(output, IPPROTO_ICMPV6, (UB*)nah - output->buf, len);

	/* 롣*/
	NET_COUNT_ICMP6(net_count_nd6[NC_ICMP6_OUT_OCTETS],
	               output->len - GET_IF_IP6_HDR_SIZE(output));
	NET_COUNT_ICMP6(net_count_nd6[NC_ICMP6_OUT_PACKETS], 1);
	NET_COUNT_MIB(icmp6_ifstat.ipv6IfIcmpOutMsgs, 1);
	NET_COUNT_MIB(icmp6_ifstat.ipv6IfIcmpOutNeighborAdvertisements, 1);
	ip6_output(output, ipflags, TMO_ND6_NS_OUTPUT);
	}

/*
 *  nd6_dad_start -- ʣɥ쥹 (DAD) 򳫻Ϥ롣
 *
 *    3tick ϡ󥿥եưƤ顢ʣФ
 *    ޤǤκǾٱͤǤ롣
 */

void
nd6_dad_start (T_IFNET *ifp, T_IN6_IFADDR *ifa, int *tick)
{
	/* ե饰å롣*/
	if (!(ifa->flags & IN6_IFF_TENTATIVE))
		return;

#if NUM_IP6_DAD_COUNT == 0

	ifa->flags &= ~IN6_IFF_TENTATIVE;

#else	/* of #if NUM_IP6_DAD_COUNT == 0 */

	if (ifa->flags & IN6_IFF_ANYCAST) {
		ifa->flags &= ~IN6_IFF_TENTATIVE;
		return;
		}
	else if ((ifa->flags & IN6_IFF_TENTATIVE) == 0)
		return;

	/* ʣɥ쥹Х󥿤ꥻåȤ롣*/
	ifa->ns_icount = ifa->na_icount = ifa->ns_ocount = 0;

	/*
	 *  ʣɥ쥹롣󥿥ե
	 *  ľˡǽϡٱԤ
	 */
	if (tick == NULL) {
		nd6_dad_ns_output(ifp, ifa);

		/* ॢȤõֳ֤ꤹ롣*/
		timeout((FP)nd6_dad_timer, ifa, ND6_RETRANS_TIME * NET_TIMER_HZ / SYSTIM_HZ);
		}
	else {
		int ntick;

		if (*tick == 0)	/* ǽ */
			ntick = net_rand() % (ND6_FIRST_DAD_DELAY_TIME * NET_TIMER_HZ / SYSTIM_HZ);
		else
			ntick = *tick + net_rand() % (ND6_DAD_DELAY_TIME * NET_TIMER_HZ / SYSTIM_HZ);
		*tick = ntick;
		timeout((FP)nd6_dad_timer, ifa, ntick);
		}

#endif	/* of #if NUM_IP6_DAD_COUNT == 0 */

	}

#endif /* of #ifdef SUPPORT_INET6 */
